var dateformatter = Components.classes["@mozilla.org/intl/scriptabledateformat;1"].getService(Components.interfaces.nsIScriptableDateFormat);
blogger = window.arguments[0];
metaWeblog = window.arguments[1];
var usemeta = window.arguments[2];

const historybundle = document.getElementById("historybundle");

function LoadPostHistory() {
	document.getElementById("historydeck").selectedIndex = 0;
	document.getElementById("hdprogress").value = historybundle.getString("WaitingForData");
	document.getElementById("loadingmeter").mode = "undetermined";
	document.getElementById("reload").disabled = true;
	document.getElementById("edit").disabled = true;
	var params = [];
	if (usemeta) {
		params.push(metaWeblog.blogs[0][0]["blogid"]);
		params.push(metaWeblog.username);
		params.push(metaWeblog.password);
		params.push(15);
		var posthistoryreq = makeXMLRpcCall("metaWeblog.getRecentPosts", params);
		metaWeblog.posthistory = new Object();
		metaWeblog.posthistory.httpreq = new XMLHttpRequest();
		metaWeblog.posthistory.httpreq.onreadystatechange = historyHandler;
		metaWeblog.posthistory.httpreq.onerror = function() {
			alert(historybundle.getString("ErrorConnecting"));
			window.close();
		}
		metaWeblog.posthistory.httpreq.open("POST", metaWeblog.posturl, true);
		metaWeblog.posthistory.httpreq.send(posthistoryreq);
	} else {
		params.push("0123456789ABCDEF");
		params.push(blogger.active);
		params.push(blogger.username);
		params.push(blogger.password);
		params.push(15);
		var posthistoryreq = makeXMLRpcCall("blogger.getRecentPosts", params);
		blogger.posthistory = new Object();
		blogger.posthistory.httpreq = new XMLHttpRequest();
		blogger.posthistory.httpreq.onreadystatechange = historyHandler;
		blogger.posthistory.httpreq.onerror = function() {
			alert(historybundle.getString("ErrorConnecting"));
			window.close();
		}
		blogger.posthistory.httpreq.open("POST", blogger.posturl, true);
		blogger.posthistory.httpreq.send(posthistoryreq);
	}
}

function historyHandler() {
	switch (getBlogHistory().readyState) {
		case 4:
			if (getBlogHistory().status == 200) {
				try {
					getBlogHistory().response = parseXMLRpcResponse(getBlogHistory().responseXML);
					if ((getBlogHistory().response["faultCode"]) || (getBlogHistory().response["faultString"])) {
						alert(historybundle.getString("ErrorGettingHistory") + " " + getBlogHistory().response["faultString"]);
					} else {
						// success!
						document.getElementById("entriestree").view = new treeView();
						document.getElementById("reload").disabled = false;
						document.getElementById("edit").disabled = false;
						document.getElementById("historydeck").selectedIndex = 1;
					}
				} catch (e) {
					alert(e);
				}
			}
			break;
		case 3:
			var downloaded = Math.floor(getBlogHistory().responseText.length / 1024);
			document.getElementById("hdprogress").value = downloaded + " " + historybundle.getString("KBDownloaded");
			break;
	}
}

function getBlogHistory() {
	if (usemeta) {
		return metaWeblog.posthistory.httpreq;
	} else {
		return blogger.posthistory.httpreq;
	}
}

function treeView() {
  	this.rowCount = getBlogHistory().response[0].length;
	this.getCellText = function(row,col) {
		switch (col.id) {
			case "datecol":
				var thedate = getBlogHistory().response[0][row]["dateCreated"];
				var postdate = dateformatter.FormatDateTime("", dateformatter.dateFormatShort, dateformatter.timeFormatNoSeconds, thedate.getFullYear(), thedate.getMonth() + 1, thedate.getDate(), thedate.getHours(), thedate.getMinutes(), thedate.getSeconds());
				return postdate;
				break;
			case "titlecol":
				if (usemeta) {
					return metaWeblog.posthistory.httpreq.response[0][row]["title"] ? metaWeblog.posthistory.httpreq.response[0][row]["title"] : metaWeblog.posthistory.httpreq.response[0][row]["description"];
				} else {
					return blogger.posthistory.httpreq.response[0][row]["content"];
				}
				break;
		}
 	}
	this.setTree = function(treebox){ this.treebox = treebox; }
	this.isContainer = function(row){ return false; }
	this.isSeparator = function(row){ return false; }
	this.isSorted = function(row){ return false; }
	this.getLevel = function(row){ return 0; }
	this.getImageSrc = function(row,col){ return null;}
	this.getRowProperties = function(row, props) {
		if (!usemeta) {
			if (getBlogHistory().response[0][row]["status"] == 0) {
				var aserv = Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService);
				props.AppendElement(aserv.getAtom("greyedout"));
			}
		}
	}
	this.getCellProperties = function(row,col,props){}
	this.getColumnProperties = function(colid,col,props) {}
}

function showEntry(tree) {
	if (tree.currentIndex >= 0) {
		var itemid = getBlogHistory().response[0][tree.currentIndex]["postid"];
		var windowid = "dsedit" + itemid;
		var postindex = tree.currentIndex; 
		var windowwatcher = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
		var editwindow = windowwatcher.getWindowByName(windowid, null);
		if (editwindow) {
			editwindow.focus();
		} else {
			if (usemeta) {
				metaWeblog.useme = true;
			}
			window.openDialog("blogger.xul",windowid,"chrome,resizable,titlebar,dialog=no", blogger, metaWeblog, postindex);
		}
	}
}
